﻿@using FinalProject.Entity;
@{
    ViewBag.Title = "TopUp List";
}
<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Top Up Ballance
    </h1>
    <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
        <li><a href="#">Transaction</a></li>
        <li class="active">Top Up</li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <div id="data-list" class="box">
        <div class="box-header with-border">
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                        title="Collapse">
                    <i class="fa fa-minus"></i>
                </button>
                <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                    <i class="fa fa-times"></i>
                </button>
            </div>
        </div>
        <div class="box-body">
            <div id="grid-topup"></div>
        </div>
        <!-- /.box-body -->
        <div class="box-footer text-right">
            <button id="btn-add" type="button" class="btn btn-primary"><i class="fa fa-plus"></i> Top Up</button>
        </div>
        <!-- /.box-footer-->
    </div>
    <div id="data-detail" class="box" style="display: none">
        <form name="form1">
            <div class="box-header with-border">
                <h3 class="box-title">Top Up Detail</h3>
                <div class="box-tools pull-right">
                    <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                            title="Collapse">
                        <i class="fa fa-minus"></i>
                    </button>
                    <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                        <i class="fa fa-times"></i>
                    </button>
                </div>
            </div>
            <div class="box-body">
                <div class="form-horizontal">
                    <div class="form-group">
                        <div class="col-md-2 control-label">Account ID</div>
                        <div class="col-md-3">
                            <input data-bind="AccountID" type="text" name="AccountID" class="form-control" readonly/>
                        </div>
                        <div class="col-md-2 control-label">Bank ID</div>
                        <div class="col-md-3">
                            <div class="input-group">
                                <input data-bind="BankID" type="text" name="BankID" class="form-control" />
                                <div class="input-group-btn">
                                    <button id="btn-select-bank" type="button" class="btn btn-primary"><i class="fa fa-bank"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Amount</div>
                        <div class="col-md-3">
                            <input data-bind="Amount" type="text" name="Amount" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Reference Number</div>
                        <div class="col-md-3">
                            <input data-bind="ReferenceNumber" type="text" name="ReferenceNumber" class="form-control" />
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Txn Number</div>
                        <div class="col-md-3">
                            <input data-bind="TxnNumber" type="text" name="TxnNumber" class="form-control" />
                        </div>
                    </div>
                </div>
            </div>
            <div class="box-footer text-center">
                <button id="btn-back" type="button" class="btn btn-default"><i class="fa fa-chevron-left"></i> Back</button>
                <button id="btn-save" type="button" class="btn btn-primary"><i class="fa fa-save"></i> Save</button>
            </div>
        </form>
    </div>
</section>
<div id="select-account" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-body">
            <div class="box box-primary">
                <div class="box-header with-border">
                    Select Account
                    <span class="close" style="color: white; opacity:1" data-dismiss="modal">&times;</span>
                </div>
                <div class="box-body">
                    <div id="grid-account"></div>
                </div>
                <div class="box-footer text-center">
                    <button type="button" class="btn btn-default" data-dismiss="modal">
                        <i class="fa fa-remove"></i> Close
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>
<div id="select-bank" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-body">
            <div class="box box-primary">
                <div class="box-header with-border">
                    Select Bank
                    <span class="close" style="color: white; opacity:1" data-dismiss="modal">&times;</span>
                </div>
                <div class="box-body">
                    <div id="grid-bank"></div>
                </div>
                <div class="box-footer text-center">
                    <button type="button" class="btn btn-default" data-dismiss="modal">
                        <i class="fa fa-remove"></i> Close
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>
@section scripts
{
    <script>
        (function () {
            function TopUp() {
                return {
                    TopupID: 0,
                    TopupDate: '',
                    AccountID: '@ViewBag.ID',
                    BankID: '',
                    Amount: '',
                    ReferenceNumber: '',
                    TxnNumber: '',
                    Status: 'PENDING',
                    CreatedDate: '',
                    ProcessDate: ''
                }
            }
            var scope = (function () {
                return Bind({
                    topup: new TopUp()
                }, {
                        "topup.AccountID": "[data-bind='AccountID']",
                        "topup.BankID": "[data-bind='BankID']",
                        "topup.Amount": "[data-bind='Amount']",
                        "topup.ReferenceNumber": "[data-bind='ReferenceNumber']",
                        "topup.TxnNumber": "[data-bind='TxnNumber']"
                    });
            }());

            var state = "new";

            var grid = gridview("grid-topup", {
                url: "/TopUp/Paging",
                columns: [
                    { field: "TopupID", text: "Topup ID", sortable: true },
                    { field: "TopupDate", text: "Topup Date", sortable: true },
                    { field: "AccountID", text: "Account ID", sortable: true },
                    { field: "BankID", text: "Bank ID", sortable: true },
                    { field: "Amount", text: "Amount", sortable: true, },
                    { field: "ReferenceNumber", text: "Reference Number", sortable: true },
                    { field: "TxnNumber", text: "TxnNumber", sortable: true },
                    { field: "Status", text: "Status", sortable: true }
                ],
                fieldKey: "TopupID"
            });

            var gridAccount = gridview("grid-account", {
                url: "/Account/Paging",
                columns: [
                    {
                        text: "", render: function (c) {
                            var tmpl = "<a action='select'><i class='fa fa-check'></i></a>";
                            return tmpl;
                        }
                    },
                    { field: "AccountID", text: "Account ID", sortable: true },
                    { field: "FirstName", text: "First tName", sortable: true },
                    { field: "Email", text: "Email", sortable: true },
                    { field: "DateOfBirth", text: "Date Of Birth", sortable: true },
                    { field: "IDNumber", text: "ID Number", sortable: true },
                    { field: "Address", text: "Address", sortable: true },
                    { field: "City", text: "City", sortable: true }
                ],
                fieldKey: "AccountID",
                select: function (tup) {
                    scope.topup.AccountID = tup.AccountID;
                    $("#select-account").modal("hide");
                },
            });

            var gridBank = gridview("grid-bank", {
                url: "/TopUp/PagingByAccountID",
                columns: [
                    {
                        text: "", render: function (c) {
                            var tmpl = "<a action='select'><i class='fa fa-check'></i></a>";
                            return tmpl;
                        }
                    },
                    { field: "BankID", text: "Bank ID", sortable: true },
                    { field: "AccountNumber", text: "Account Number", sortable: true },
                    { field: "Branch", text: "Branch", sortable: true },
                    { field: "AccountID", text: "AccountID", sortable: true },
                    { field: "CreateDate", text: "Create Date", sortable: true }
                ],
                fieldKey: "BankID",
                select: function (bnk) {
                    scope.topup.BankID = bnk.BankID;
                    $("#select-bank").modal("hide");
                },
            });

            function getDate() {
                var d = new Date();
                return data = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
            }
            function formatNumber(num) {
                return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.') + ',00'
            }
            function showDetail() {
                state = "new";
                scope.topup = new TopUp();
                scope.topup.TopupDate = getDate();
                scope.topup.CreatedDate = getDate();
                $("#data-list").fadeOut(250, function () { $("#data-detail").fadeIn(500) });
                $("[name=BankID]").attr("readonly", true);
            }
            function showList() {
                $("#data-detail").fadeOut(250, function () { $("#data-list").fadeIn(500) });
            }
            function save() {
                var url = "/TopUp/" + (state === "new" ? "Insert" : "Update");

                axios.post(url, { topup: scope.topup })
                    .then(function (res) { return res.data; }, function (err) { console.log("Err: ", er); })
                    .then(function (res) {
                        if (res.meta.success) {
                            Swal.fire("Success", "Save data success", "success")
                                .then(function (r) {
                                    showList();
                                    grid.reload();
                                });
                        } else {
                            Swal.fire("Error", res.meta.message, "error");
                        }
                    }); 
            }
            $("#btn-add").click(showDetail);
            $("#btn-back").click(function () { showList(); });
            $("#btn-select-account").click(function () { $("#select-account").modal(); });
            $("#btn-select-bank").click(function () { $("#select-bank").modal(); });
            $("#btn-save").click(save);
        }());
    </script>
}